#ifndef __TCUBE_HH
#define __TCUBE_HH
//
// Project : lib3D
// File    : TGraphObject.hh
// Purpose : class representing a cube
// Author  : Ronald Kriemann
//
// arch-tag: 1b2cd37e-0106-4234-933f-450c1f438992
//

#include "TGraphObject.hh"

namespace RGL
{

//
//
//
class TCube : public TGraphObject
{
public:

    ///////////////////////////////////////
    //
    // constructor and destructor
    //

    TCube () {}

    ~TCube () {}
    
    //////////////////////////////////////////////////
    //
    // raytracing methods
    //

    // compute intersection with ray
    // - return true if intersected, else false
    virtual bool intersect ( const TRay & ray, real & dist ) const;

    // compute normal at point
    virtual bool calc_normal ( const TVector & point,
                               TVector       & normal ) const;

    //////////////////////////////////////////////////
    //
    // misc. methods
    //

    // store bounding box defined by xy, xz and yz planes
    // in given vectors
    virtual bool bounding_box ( TVector & min, TVector & max ) const;

    // print object
    virtual void print () const;
    
    //////////////////////////////////////////////////
    //
    // virtual constructors
    //

    virtual TCube * clone () const { return new TCube; }
    virtual TCube * copy  () const { return (TCube*) TGraphObject::copy(); }
};

}// namespace

#endif // __TCUBE_HH
