#ifndef __TMEMORY_HH
#define __TMEMORY_HH
//
// Project : misc
// File    : TMemory.hh
// Purpose : class for gathering information about memory
// Author  : Ronald Kriemann
//
// arch-tag: b81686d1-77b2-483b-ba55-5a513fb3caa5
//

#include <iostream>

namespace RGL
{

//
// give info about memory usage
//
class TMemory
{
protected:
    // base value of memory usage
    unsigned long  _base;
    
public:
    ////////////////////////////////////////////////
    //
    // constructor
    //

    TMemory () { _base = 0; }
    
    TMemory ( const TMemory & mem )
    { *this = mem; }

    ////////////////////////////////////////////////
    //
    // access local variables
    //

    // define base memory as current memory usage
    void set_base () { _base = used(); }

    // reset base value to zero
    void reset_base () { _base = 0; }
    
    ////////////////////////////////////////////////
    //
    // return byte usage
    //

    // return used memory in bytes - base
    unsigned long used () const;

    ////////////////////////////////////////////////
    //
    // misc.
    //

    // copy operator
    TMemory & operator = ( const TMemory & mem ) 
    {
        _base = mem._base;
        return *this;
    }
    
    // stream-output
    friend std::ostream & operator << ( std::ostream & os, const TMemory & m );
};

//
// global object for memory-info
//

extern TMemory  MEMORY;

} // namespace

#endif  // __TMEMORY_HH
