//
// Project : lib3D
// File    : TWorld.cc
// Purpose : Declaration of a class for managing all graphical objects
// Author  : Ronald Kriemann
//
// arch-tag: ea59ef3b-b513-442b-a6ca-ff4b4be46733
//

#include <stdlib.h>

#include "TTimer.hh"
#include "TMemory.hh"

#include "TWorld.hh"

namespace RGL
{

//////////////////////////////////////////////////
//
// constructor and destructor
//

TWorld::TWorld ()
{
}

TWorld::~TWorld ()
{
    TObjIterator  iter;

    iter = _obj_list.first();
    while ( ! iter.eol() )
    {
        delete iter.data();
        iter.next();
    }// while
}

//////////////////////////////////////////////////
//
// manage objects
//

void
TWorld::add ( TGraphObject * obj )
{
    _obj_list.append( obj );
}

//
// add a light to the world
//
void
TWorld::add_light ( TLight * light )
{
    if ( light != NULL )
        _lights.append( light );
}

void
TWorld::transform ()
{
    TObjIterator   iter;
    static real  f = 1.0;
    
    f += 0.1;

    iter = _obj_list.first();
    while ( ! iter.eol() )
    {
        iter.next();
    }// while
}

} // namespace

